#pragma once
//////////////////////////////////////////////////////////////////////
// SimpleSa.h: interface for the Sa class.
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionColor.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{
	class SimpleSa 
	{
	public:
		SimpleSa();
		~SimpleSa();
		void init();
		void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
		bool update(float dt);

		// keyframe animation
		void setKeyframeAnimation(std::vector<KeyFrame> frames_);
		void activate() { active = true; }
		void deactivate() { active = false; }
		bool isAnimationDone() { return done; }
		bool isActive() { return active; }
		void reset() { active = false; done = false; }

	protected:
		glm::vec3 position;
		glm::mat4 bodyTransform;
		Parallelepiped pipe[4];

		// keyframe animation
		std::vector<KeyFrame> keyframes; 
		bool done = false;
		bool active = false;
		CatmullRomCurveAnimation * curve = NULL;
	};

}